;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: USBFS_1_drv.asm
;;  Version: 1.0, Updated on 2005/10/13 at 10:19:15
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: USB Device User Module control endpoint driver
;;               for the CY8C24090 family of devices
;;
;;  NOTE: User Module APIs conform to the fastcall16 convention for marshalling
;;        arguments and observe the associated "Registers are volatile" policy.
;;        This means it is the caller's responsibility to preserve any values
;;        in the X and A registers that are still needed after the API functions
;;        returns. For Large Memory Model devices it is also the caller's 
;;        responsibility to perserve any value in the CUR_PP, IDX_PP, MVR_PP and 
;;        MVW_PP registers. Even though some of these registers may not be modified
;;        now, there is no guarantee that will remain the case in future releases.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2005. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "USBFS_1_macros.inc"
include "USBFS_1.inc"

;-----------------------------------------------
;  Global Symbols		 
;-----------------------------------------------
export _USBFS_1_EP0_ISR
export  USBFS_1_InitControlRead
export _USBFS_1_InitControlRead
export  USBFS_1_InitControlWrite
export _USBFS_1_InitControlWrite
export  USBFS_1_InitNoDataStageControlTransfer
export _USBFS_1_InitNoDataStageControlTransfer
export  USBFS_1_NoDataStageControlTransfer

;-----------------------------------------------
;  Macro Definitions
;-----------------------------------------------

;-----------------------------------------------
;  Constant Definitions
;-----------------------------------------------

;-----------------------------------------------
; Variable Allocation
;-----------------------------------------------
AREA InterruptRAM (RAM,REL,CON)
;----------------------------------------------------------------------------
; Current Device
;----------------------------------------------------------------------------
EXPORT USBFS_1_bCurrentDevice, _USBFS_1_bCurrentDevice
 USBFS_1_bCurrentDevice:
_USBFS_1_bCurrentDevice:                BLK   1    ;  Current Device
;----------------------------------------------------------------------------
; Current Configuration
;----------------------------------------------------------------------------
EXPORT USBFS_1_Configuration, _USBFS_1_Configuration
 USBFS_1_Configuration:
_USBFS_1_Configuration:                 BLK   1    ;  Current Configuration
;----------------------------------------------------------------------------
; Current Device Status
;----------------------------------------------------------------------------
EXPORT USBFS_1_DeviceStatus, _USBFS_1_DeviceStatus
 USBFS_1_DeviceStatus:
_USBFS_1_DeviceStatus:                  BLK   1    ;  Current Device Status
;----------------------------------------------------------------------------
; Interface Setting
;----------------------------------------------------------------------------
; TODO: User Module Parameter determines the number of interfaces
EXPORT USBFS_1_InterfaceSetting, _USBFS_1_InterfaceSetting
 USBFS_1_InterfaceSetting:
_USBFS_1_InterfaceSetting:              BLK   1    ; Interface Setting
;----------------------------------------------------------------------------
; Endpoint Status--USB Status
;----------------------------------------------------------------------------
EXPORT USBFS_1_EndpointStatus, _USBFS_1_EndpointStatus
 USBFS_1_EndpointStatus:
_USBFS_1_EndpointStatus:                BLK   USB_NUM_ENDPOINTS    ; Endpoint Status
;----------------------------------------------------------------------------
; Last Packet Size
;----------------------------------------------------------------------------
EXPORT USBFS_1_LastSize 
 USBFS_1_LastSize:                      BLK   1    ; Last Packet Size
;----------------------------------------------------------------------------
; Control Transfer State Machine
; State values for Control Write
; State values for Control Read
;----------------------------------------------------------------------------
EXPORT USBFS_1_TransferType 
 USBFS_1_TransferType:                  BLK   1    ; Control Transfer State Machine
;----------------------------------------------------------------------------
; Control Transfer Intermediate Buffer--Shared among the requests
;----------------------------------------------------------------------------
EXPORT USBFS_1_TransferBuffer 
 USBFS_1_TransferBuffer:                BLK   8
;----------------------------------------------------------------------------
; Transfer Descriptor Data for Control Transfer
;  --The following data have the same format as the first 5 bytes of the TD_ENTRY
;----------------------------------------------------------------------------
; Control Transfer Data Source
;   USB_DS_ROM
;   USB_DS_RAM
;   USB_DS_RAM_AS_NEEDED
;----------------------------------------------------------------------------
EXPORT USBFS_1_CurrentTD, _USBFS_1_CurrentTD
_USBFS_1_CurrentTD:
 USBFS_1_CurrentTD:
EXPORT USBFS_1_DataSource, _USBFS_1_DataSource
_USBFS_1_DataSource:
 USBFS_1_DataSource:                    BLK   1
;----------------------------------------------------------------------------
; Control Transfer Data Size
;----------------------------------------------------------------------------
EXPORT USBFS_1_TransferSize, _USBFS_1_TransferSize
_USBFS_1_TransferSize:
 USBFS_1_TransferSize:                  BLK   2
;----------------------------------------------------------------------------
; Control Transfer Data Pointer
;   Source for Control Read
;   Destination for Control Write
;----------------------------------------------------------------------------
EXPORT USBFS_1_DataPtr, _USBFS_1_DataPtr
_USBFS_1_DataPtr: 
 USBFS_1_DataPtr:                       BLK   2
;----------------------------------------------------------------------------
; Transfer Completion Notification
;----------------------------------------------------------------------------
EXPORT USBFS_1_StatusBlockPtr, _USBFS_1_StatusBlockPtr
_USBFS_1_StatusBlockPtr: 
 USBFS_1_StatusBlockPtr:                BLK   2

;----------------------------------------------------------------------------
; Control Transfer _TransferByteCount (Actually transfered
;----------------------------------------------------------------------------
 USBFS_1_TransferByteCount:             BLK   2

;----------------------------------------------------------------------------
; Control Endpoint Data toggle
EXPORT USBFS_1_EPDataToggle, _USBFS_1_EPDataToggle
 _USBFS_1_EPDataToggle:
 USBFS_1_EPDataToggle:
 USBFS_1_EP0DataToggle:                 BLK   USB_NUM_ENDPOINTS
;----------------------------------------------------------------------------
; Control Endpoint Data Pending Flag
EXPORT USBFS_1_fDataPending
 USBFS_1_fDataPending:                  BLK   1
;----------------------------------------------------------------------------
; Control Endpoint Data Pending Flag
EXPORT USBFS_1_PendingData
  USBFS_1_PendingData:                  BLK   1

;----------------------------------------------------------------------------
; Temporary Data registers
EXPORT USBFS_1_t2, USBFS_1_t1, USBFS_1_t0
 USBFS_1_t2:                            BLK   1    ; Temporary shared by the UM
 USBFS_1_t1:                            BLK   1    ; Temporary shared by the UM
 USBFS_1_t0:                            BLK   1    ; Temporary shared by the UM

EXPORT USBFS_1_IntState
 USBFS_1_IntState:                      BLK  1
EXPORT USBFS_1_StackPointer
 USBFS_1_StackPointer:                  BLK  1
EXPORT USBFS_1_TempMode 
 USBFS_1_TempMode:                      BLK 1
;----------------------------------------------------------------------------
; Endpoint Transfer--API Status
;----------------------------------------------------------------------------
EXPORT USBFS_1_EndpointAPIStatus, _USBFS_1_EndpointAPIStatus
 USBFS_1_EndpointAPIStatus:
_USBFS_1_EndpointAPIStatus:             BLK   USB_NUM_ENDPOINTS    ; Endpoint Status

IF 1
ELSE
ERROR_RUN_USB_WIZARD
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; In order for the USB User Module to compile properly the USB Wizard must be run.  
; To do this navigate back to the Device Editor Window, right click on the icon for the 
; USB User Module and select the 'USB Setup Wizard...'.  Configure the device as needed
; and then click OK.  Re-generate source before compiling again.
; For HID devices it is important that all instances of HID Class Descriptors point to a valid 
; HID report.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ENDIF

AREA UserModules (ROM, REL)
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_EP0_ISR
;
;  DESCRIPTION: This is the entry point into the Endpoint 0 ISR.  EP0 is 
;               responsible for control transfers and is therefore used
;               for device enumeration
;
 USBFS_1_EP0_ISR:
_USBFS_1_EP0_ISR:
	push A
	push X
    REG_PRESERVE MVW_PP
    REG_PRESERVE MVR_PP

    RAM_SETPAGE_MVW 0
    RAM_SETPAGE_MVR 0 

    ; Dispatch to setup/in/out handlers
    mov  A, reg[USBFS_1_EP0MODE]        ; Get the mode reg 

    mov  [USBFS_1_TempMode], USB_MODE_NAK_IN_OUT  
    mov  reg[USBFS_1_EP0MODE], USB_MODE_NAK_IN_OUT
    ; MSB is the SETUP bit, followed by IN, then OUT
    asl	 A                              ; Shift to the carry and jump if SETUP bit set    
    jc	 USBFS_1_EP0_Setup

    asl	 A                              ; Shift to the carry and jump if IN bit set
    jc	 USBFS_1_EP0_IN

    asl	 A                              ; Shift to the carry and jump if OUT bit set
    jc	 USBFS_1_EP0_OUT
    
    ljmp  USBFS_1_Not_Supported
; Common Exit Point
USBFS_1_EP0_ISR_EXIT:
    REG_RESTORE MVR_PP
    REG_RESTORE MVW_PP    
    pop  X                              ; 
	mov  A, [USBFS_1_TempMode] 
	mov  reg[USBFS_1_EP0MODE], A
    pop  A                              ; Restore Context
;    mov  [USBFS_1_IntState], 0
    reti
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_EP0_Setup
;
;  DESCRIPTION: Dispatches handlers for the specific setup request received
;
 USBFS_1_EP0_Setup:
_USBFS_1_EP0_Setup:
; Check the byte count and validity.  All SETUP are 8 bytes and 0 toggle
    push A
	mov  A, USB_XFER_PREMATURE
	call USBFS_1_UpdateStatusBlock
	pop  A
    mov  A, reg[USBFS_1_EP0CNT]              ; Get the count reg
    cmp  A, (USB_CNT_VALID | 0x0A)            
    jz   .dispatch

    jmp  USBFS_1_Not_Supported_Local2
;-----------------------------------------------------------------------------
; Jump here to dispatch the request
; The SETUP request is encoded in [bmRequestType]. Among the 8 bits in [bmRequestType], only bits
; 7,6,5,1,0 determine what the request is. Bits [2:4] are default to zero. The below code
; re-organizes [bmRequestType] to the following format: 
; ( Zero, Zero, Bit7, Bit6, Bit5, Bit1, Bit0, Zero ), and depending on the value of this
; "re-organization", the firmware will jump to an appropriate table to handle the request.		
;-----------------------------------------------------------------------------
.dispatch:
    mov  A, REG[USBFS_1_EP0DATA+bmRequestType]   ; Get bmRequestType
    and  A, E3h                              ; clear bits 4-3-2, these unused for our purposes
    push A                                   ; store value on the stack
    asr  A                                   ; move bits 7-6-5 into 4-3-2's place
    asr  A                                   ; "asr" instruction shift all bits one place to the right.
    asr  A                                   ; Bit7 remains the same.
    mov  [USBFS_1_t2], A                     ; store shifted value
    pop  A                                   ; get original value
    or   A, [USBFS_1_t2]                     ; or the two to get the 5-bit field
    and  A, 1Fh                              ; clear bits 7-6-5 (asr wraps bit7)

                                             ; Bit0 is loaded with a Zero. This results in multiplying 
                                             ; the accumulator by 2, and the reason to mutiply it by 2 
                                             ; is that each "jmp" instruction in the tables is two bytes long.

    call USBFS_1_bmRequestType_Dispatch
    jmp  USBFS_1_EP0_ISR_EXIT                ; And exit
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_EP0_IN
;
;  DESCRIPTION: Handles an IN request.  Depending on the state of the 
;               enumeration sequence it decides what to do next
;
 USBFS_1_EP0_IN:
_USBFS_1_EP0_IN:
   
    mov  A, [USBFS_1_TransferType]
    call USBFS_1_ControlInDispatch
    jmp  USBFS_1_EP0_ISR_EXIT                ; And exit
USBFS_1_ControlInDispatch:               
    jacc USBFS_1_ControlInDispatchTable
USBFS_1_ControlInDispatchTable:
    jmp  USBFS_1_Not_Supported_Local2            ; USB_TRANS_STATE_IDLE
    jmp  USBFS_1_ControlReadDataStage     ; USB_TRANS_STATE_CONTROL_READ
    jmp  USBFS_1_ControlWriteStatusStage  ; USB_TRANS_STATE_CONTROL_WRITE
    jmp  USBFS_1_NoDataControlStatusStage ; USB_TRANS_STATE_NO_DATA_CONTROL
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_EP0_OUT
;
;  DESCRIPTION: Handles an OUT request.  Depending on the state of the 
;               enumeration sequence it decides what to do next
;
 USBFS_1_EP0_OUT:
_USBFS_1_EP0_OUT:

    mov  A, [USBFS_1_TransferType]
    call USBFS_1_ControlOutDispatch
    jmp  USBFS_1_EP0_ISR_EXIT                ; And exit
USBFS_1_ControlOutDispatch:               
    jacc USBFS_1_ControlOutDispatchTable

USBFS_1_ControlOutDispatchTable:
    jmp  USBFS_1_Not_Supported_Local2            ; USB_TRANS_STATE_IDLE
    jmp  USBFS_1_ControlReadStatusStage   ; USB_TRANS_STATE_CONTROL_READ
    jmp  USBFS_1_ControlWriteDataStage    ; USB_TRANS_STATE_CONTROL_WRITE
    jmp  USBFS_1_NoDataControlError       ; USB_TRANS_STATE_NO_DATA_CONTROL

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_InitControlRead
;
;  DESCRIPTION: If the setup packet is determined to be requesting data
;               this function is called to Initialize the state machine
;               to handle upcoming IN requests
;
 USBFS_1_InitControlRead:
_USBFS_1_InitControlRead:
    mov  [USBFS_1_LastSize], A
	call USBFS_1_InitializeStatusBlock
    mov  [USBFS_1_TransferType], USB_TRANS_STATE_CONTROL_READ
    
    ; Check the transfer size against the request size
    mov  A, REG[USBFS_1_EP0DATA+wLengthHi] ; MSB of wLength
    cmp  A, [USBFS_1_TransferSize]
    jnz  .L1

    mov  A, REG[USBFS_1_EP0DATA+wLengthLo] ; LSB of wLength
    cmp  A, [USBFS_1_TransferSize+1]
    jz   .L9
.L1:
    jnc  .L9
;    
    mov  [USBFS_1_TransferSize+1], A   ; 
    mov  A, REG[USBFS_1_EP0DATA+wLengthHi] ; 
    mov  [USBFS_1_TransferSize], A     ; 
.L9:
    mov  [USBFS_1_TransferByteCount], 0; 
    mov  [USBFS_1_TransferByteCount+1], 0 ; 

    mov  [USBFS_1_EP0DataToggle], USB_CNT_TOGGLE
    jmp  USBFS_1_LoadEndpoint          ; 

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_ControlReadDataStage
;
;  DESCRIPTION: Handles Loading of data for the non-zeroth IN request during
;               a control read transaction
;
 USBFS_1_ControlReadDataStage:
    jmp   USBFS_1_LoadEndpoint

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_ControlReadStatusStage
;
;  DESCRIPTION: After all data has been transmitted the status stage is 
;               invoked
;
 USBFS_1_ControlReadStatusStage:
    mov  A, [USBFS_1_LastSize]
	add  [USBFS_1_TransferByteCount + 1], A
	adc  [USBFS_1_TransferByteCount], 0
	mov  A, USB_XFER_STATUS_ACK
	call USBFS_1_UpdateStatusBlock
    mov  [USBFS_1_TempMode], USB_MODE_STATUS_OUT_ONLY
    mov  [USBFS_1_TransferType], USB_TRANS_STATE_IDLE
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_NoDataStageControlTransfer
;
;  DESCRIPTION: Send a 0 length packet to indicate the end of a control
;               transfer or to acknowledge the receipt of data
;
 USBFS_1_NoDataStageControlTransfer:
_USBFS_1_InitNoDataStageControlTransfer:
 USBFS_1_InitNoDataStageControlTransfer:
    call    USBFS_1_InitializeStatusBlock
 
    mov  [USBFS_1_TransferType], USB_TRANS_STATE_NO_DATA_CONTROL
    
    mov  REG[USBFS_1_EP0CNT], 0
    mov  [USBFS_1_TempMode], USB_MODE_STATUS_IN_ONLY
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_InitControlWrite
;
;  DESCRIPTION: In the case when the host wishes to write data to the device
;               this function initializes the state machine to handle 
;               the subsequent out requests
;
 USBFS_1_InitControlWrite:
_USBFS_1_InitControlWrite:
    mov   A, [USBFS_1_DataSource]      ; Need to make sure the destination is not ROM
    cmp   A, USB_DS_ROM
    jz    USBFS_1_Not_Supported_Local2

    call    USBFS_1_InitializeStatusBlock

    mov   [USBFS_1_TransferType], USB_TRANS_STATE_CONTROL_WRITE

    mov  A, USB_CNT_TOGGLE             ; Initialize the data toggle for next time    
    mov  [USBFS_1_EP0DataToggle], A
    mov  REG[USBFS_1_EP0CNT], A
    mov  [USBFS_1_TempMode], USB_MODE_ACK_OUT_STATUS_IN
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_ControlWriteDataStage
;
;  DESCRIPTION: Handles the non-zeroth OUT transfer of the a Control Write
;               transaction
;
 USBFS_1_ControlWriteDataStage:
    mov  A, REG[USBFS_1_EP0CNT]        ; Get the count
    and  A, USB_CNT_TOGGLE             ; Check the data toggle                     ;
    xor  A, [USBFS_1_EP0DataToggle]    ;

    xor  [USBFS_1_EP0DataToggle], USB_CNT_TOGGLE  ; Update data toggle

    mov  A,REG[USBFS_1_EP0CNT]         ; Get the count

    and   A, 0x0F
    sub   A, 2                         ; Count include the two byte checksum

    mov   [USBFS_1_t2], A              ; Assume we have room to receive the whole packet             

    mov   A, 0
    cmp   A, [USBFS_1_TransferSize]    ; If the MSB has anything just use the count
    jnz   .L1

    mov   A, [USBFS_1_t2]
    cmp   A, [USBFS_1_TransferSize+1]  ; 
    jz    .L6
.L1:
    jc    .L6
    mov   [USBFS_1_t2], [USBFS_1_TransferSize+1]

.L6: 
    mov   A, [USBFS_1_t2]
    sub   [USBFS_1_TransferSize+1],A   ; Update the bytes remaining
    sbb   [USBFS_1_TransferSize], 0    ;

    add   [USBFS_1_TransferByteCount + 1], A ; Update the transfer byte count 
    adc   [USBFS_1_TransferByteCount], 0 ; 

    mov   X,0                          ; Start the index at 0

.RAM_COPY:
    mov   A, REG[X+USBFS_1_EP0DATA]    ; Get the data
    mvi   [USBFS_1_DataPtr+1], A       ; Store the data, bump the destination

    inc   X                            ; Bump the destination offset
    mov   A,X                          ; Are we done?
    cmp   A, [USBFS_1_t2]
    jc    .RAM_COPY                    ; Not done

    mov   [USBFS_1_TempMode], USB_MODE_ACK_OUT_STATUS_IN  
    ret

; Jump here on data toggle error
.error:
    mov   [USBFS_1_TransferType], USB_TRANS_STATE_IDLE  ; This simply aborts the transfer

    mov  [USBFS_1_TempMode], USB_MODE_STALL_IN_OUT  ; 
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_ControlWriteStatusStage
;
;  DESCRIPTION: Handles the Status stage of a control write by setting the
;               endpoint to STALL IN/OUT 
;
 USBFS_1_ControlWriteStatusStage:
    mov  A, USB_XFER_STATUS_ACK        ; Return a Status ACK Completion
    call USBFS_1_UpdateStatusBlock
    mov  [USBFS_1_TransferType], USB_TRANS_STATE_IDLE  ; The packet is done
    mov  [USBFS_1_TempMode], USB_MODE_STALL_IN_OUT  ; Wait for the next SETUP
    ret

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_NoDataControlStatusStage
;
;  DESCRIPTION:
;
 USBFS_1_NoDataControlStatusStage:
    mov  A, USB_XFER_STATUS_ACK        ; Return a Status ACK Completion
    call USBFS_1_UpdateStatusBlock
    ; Dispatch to the proper handler
    cmp  [USBFS_1_fDataPending], USB_ADDRESS_CHANGE_PENDING
    jnz  .L1

    ; USB ADDRESS CHANGE
    mov  A, [USBFS_1_TransferBuffer]   ; Get the pending data

    or   A, USB_ADDR_ENABLE            ; Set the enable bit
    mov  REG[USBFS_1_ADDR], A          ; Update the SIE address
    jmp  .EXIT
.L1:

.EXIT:
    mov   [USBFS_1_fDataPending], 0    ; Clear data pending

    mov   [USBFS_1_TempMode], USB_MODE_STATUS_IN_ONLY ; Wait for the next SETUP
    ret

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_NoDataControlError
;
;  DESCRIPTION:
;
 USBFS_1_NoDataControlError:
    mov  A, USB_XFER_ERROR             ; Return Transaction Error
    call USBFS_1_UpdateStatusBlock
    mov  [USBFS_1_TempMode], USB_MODE_STALL_IN_OUT
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_LoadEndpoint
;
;  DESCRIPTION: Moves data from either RAM or ROM - depending on the request
;               type and then places the appropriate number of bytes - 
;               depending on the request size into the endpoint FIFO.  
;               It finally sets up the endpoint to send data.
;
USBFS_1_LoadEndpoint:
    mov   A, [USBFS_1_LastSize]        ; Get the number of bytes from the last transfer
    add   [USBFS_1_TransferByteCount + 1], A ; Update the transfer byte count 
    adc   [USBFS_1_TransferByteCount], 0 ; 
    mov   A,  [USBFS_1_TransferSize]   ; Check to see if we have any
    or    A,  [USBFS_1_TransferSize+1] ;  more data to send
    jnz   .cont                        ; Jump if we have to send more data

; Flow here if there is no more data to send
    cmp   [USBFS_1_LastSize], 8        ; Was it a full packet?
    jz    .START_TRANSFER              ; Jump if it was full (need to send a zero length)

; Flow here if we are entering the status stage
    mov   A,[USBFS_1_EP0DataToggle]    ; move in the data toggle
    xor   [USBFS_1_EP0DataToggle], USB_CNT_TOGGLE    ; Update the data toggle for next time
    mov   reg[USBFS_1_EP0CNT], A       ; Set the count register
    mov   [USBFS_1_LastSize], A        ; Clear the byte count
    mov   [USBFS_1_TempMode],USB_MODE_STATUS_OUT_ONLY  ; Set the mode register

    ret

; Jump here to determine how many bytes should we transfer
.cont:

    ; How many bytes should we transfer
    cmp   [USBFS_1_TransferSize], 0    ; Check the MSB
    jnz   .L1

    cmp   [USBFS_1_TransferSize+1], 8  ; Check the LSB
    jnc   .L1

    mov   A,[USBFS_1_TransferSize+1]   ; Transfer all the remaing data
    jmp   .L3
    
.L1:
    mov   A, 8                         ; Just transfer the next 8 bytes

.L3:
 
    sub   [USBFS_1_TransferSize+1],A   ; Update the bytes remaining
    sbb   [USBFS_1_TransferSize],0 

    mov   [USBFS_1_t2],A               ; Save the count             
    mov   X,0
    
    cmp   [USBFS_1_DataSource],USB_DS_ROM  ; RAM or ROM copy?
    jnz   .RAM_COPY

;-------------------------
; Copy data from a ROM source
.ROM_COPY:
    push  X                            ; Save the destination offset
    mov   A,[USBFS_1_DataPtr]          ; Get the transfer source MSB
    mov   X,[USBFS_1_DataPtr+1]        ; Set the transfer source LSB
    inc   [USBFS_1_DataPtr+1]          ; Increment the data pointer
    adc   [USBFS_1_DataPtr], 0         ;   MSB if necessary

    romx                               ; Get the data byte

    pop   X                            ; Get the destination offset
    mov   REG[X + USBFS_1_EP0DATA], A  ; Load the data
    inc   X                            ; Bump the destination offset
    mov   A,X                          ; Are we done?
    cmp   A, [USBFS_1_t2]
    jc    .ROM_COPY                    ; Not done
    jmp   .START_TRANSFER              ; Otherwise go start the transfer

; Copy data from a RAM source
.RAM_COPY:
    mvi   A, [USBFS_1_DataPtr+1]       ; Get the data, bump the source

    mov   REG[X +USBFS_1_EP0DATA], A   ; Load the data
    inc   X                            ; Bump the destination offset
    mov   A,X                          ; Are we done?
    cmp   A, [USBFS_1_t2]
    jc    .RAM_COPY                    ; Not done

;; Set up the IN transfer count/mode/etc
;    A contains the byte count
.START_TRANSFER:
    mov   [USBFS_1_LastSize], A        ; Save the packet size?
    or    A,[USBFS_1_EP0DataToggle]    ; Or in the data toggle
    xor   [USBFS_1_EP0DataToggle], USB_CNT_TOGGLE    ; Update the data toggle for next time
    mov   REG[USBFS_1_EP0CNT], A       ; Set the count register
    mov   [USBFS_1_TempMode],USB_MODE_ACK_IN_STATUS_OUT  ; Set the mode register

    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_GetTableEntry
;
;  DESCRIPTION: This function figures out based on the various bytes in the
;               setup packet where to get the data from or put the data to.
;               Transfer Data structures are defined each of the supported
;               control transfers, this function finds the right one and 
;               saves it in the CurrentTD structure in RAM.  It then 
;               calles InitControlRead or InitControlWrite to being the 
;               transaction.
;
EXPORT USBFS_1_GetTableEntry
USBFS_1_GetTableEntry:

    inc   X                            ; Point to the first table entry
    adc   A, 0                         ;

    TD_INDEX_TO_OFFSET USBFS_1_t2 ; Convert the index

    swap  A, X
    add   A, [USBFS_1_t2]
    swap  A, X
    adc   A, 0                         ; A:X now points to the descriptor table entry we want

; Flow here to load the Transfer Descriptor (TD_ENTRY)
    mov  [USBFS_1_t2], USBFS_1_CurrentTD  ; Use Temp as MVI pointer
    call USBFS_1_GETBYTE               ; Get the descriptor data source
    call USBFS_1_GETWORD               ; Get the descriptor size
    call USBFS_1_GETWORD               ; Get the descriptor address
	call USBFS_1_GETWORD                  ; Get the Status Pointer
; Dispatch to InitControlRead or InitControlWrite based on d2h/h2d in the request
    mov  A, REG[USBFS_1_EP0DATA+bmRequestType] ; Get bmRequestType

    and  A,0x80                             ; Control Read or Write
    jz   .control_write

    jmp  USBFS_1_InitControlRead

.control_write:
    jmp  USBFS_1_InitControlWrite

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_LOOKUP
;
;  DESCRIPTION:    Returns the address of an entry in a lookup table (LT_ENTRY)
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A:X Point to the lookup table
;                USBFS_1_t2 contain the table index
;
EXPORT USBFS_1_LOOKUP
USBFS_1_LOOKUP:
    inc  X                             ; Point to the first table entry
    adc  A, 0                          ;

    LT_INDEX_TO_OFFSET USBFS_1_t2      ; Convert the index
    swap  A, X
    add   A, [USBFS_1_t2]              ;
    swap  A, X
    adc   A, 0
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_GETWORD/USBFS_1_GETBYTE
;
;  DESCRIPTION:    Get a word value from ROM
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:    A:X is the ROM Address
;                USBFS_1_t2 is the destination address
;
;  RETURNS:      USBFS_1_t1
;
EXPORT USBFS_1_GETWORD
USBFS_1_GETWORD:

    push A                             ; Don't loose the pointer MSB
    romx                               ; Data source flag
    mvi  [USBFS_1_t2], A               ; Save the data source
    pop  A                             ; Get the MSB back
    inc  X                             ; Point to the next  entry
    adc  A, 0                          ;

EXPORT USBFS_1_GETBYTE
USBFS_1_GETBYTE:

    push A                             ; Don't loose the pointer MSB
    romx                               ; Data source flag
    mvi  [USBFS_1_t2], A               ; Save the data source
    pop  A                             ; Get the MSB back
    inc  X                             ; Point to the next  entry
    adc  A, 0                          ;
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_GET_DEVICE_TABLE_ENTRY
;
;  DESCRIPTION:    Get the address of the current DEVICE_TABLE entry
;                  Not intended for use by C fucntions 
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;
;  RETURNS:        A:X points the the current DEVICE_TABLE entry
;                  Carry flag is set if the current device index is out of range
;
EXPORT USBFS_1_GET_DEVICE_TABLE_ENTRY
USBFS_1_GET_DEVICE_TABLE_ENTRY:
    mov  [USBFS_1_t2], [USBFS_1_bCurrentDevice]  ; Use the UM temp var--Selector

    mov  A,>USBFS_1_DEVICE_LOOKUP      ; Get the ROM Address MSB
    mov  X,<USBFS_1_DEVICE_LOOKUP      ; Get the ROM Address LSB
    romx                               ; First entry is the table size (only a byte)
    cmp  A, [USBFS_1_t2]               ; Range check
    mov  A,>USBFS_1_DEVICE_LOOKUP      ; Get the ROM Address MSB
    jc   .exit
; Flow here if the index is valid
    call USBFS_1_LOOKUP                ; Look up the configuration
; Jump or flow here on exit
.exit:
    ret
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_GET_CONFIG_TABLE_ENTRY
;
;  DESCRIPTION:    Get the address of the current DEVICE_TABLE entry
;                  Not intended for use by C fucntions
;                  Does not do range checking on  
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;
;  RETURNS:        A:X points the the current CONFIG_TABLE entry
;                  Carry flag is set if the current device index is out of range
;
EXPORT USBFS_1_GET_CONFIG_TABLE_ENTRY
USBFS_1_GET_CONFIG_TABLE_ENTRY:
    call USBFS_1_GET_DEVICE_TABLE_ENTRY  ; Get the selected device
    mov  [USBFS_1_t2],USBFS_1_t1       ; Set the GETWORD destination 
    call USBFS_1_GETWORD               ; Get the pointer to the CONFIG_LOOKUP table
                                       ; ITempW has the address
    mov  A, REG[USBFS_1_EP0DATA+wValueLo]  ; Get the configuration number
    mov  [USBFS_1_t2],A                ; Save it 
    mov  A, [USBFS_1_t1]               ; Get the CONFIG_LOOKUP ROM Address MSB
    mov  X, [USBFS_1_t1+1]             ; Get the CONFIG_LOOKUP ROM Address LSB

; A:X Points to the CONFIG_LOOKUP, so get the current entry        
    mov   [USBFS_1_t2], [USBFS_1_Configuration] ; Get the configuration number
    dec   [USBFS_1_t2]                 ; We don't populate the 0th entry
    call  USBFS_1_LOOKUP               ; Look up the configuration
    ret

;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_UpdateStatusBlock
;
;  DESCRIPTION:    Update the Completion Status Block for a Request.  The
;                  block is updated with the completion code from the
;                  argument (A) and the _TransferByteCount.
;                  
;                  The StatusBlock Pointer (_StatusBlockPtr) is set to NULL (0)
;                  to make sure no other updates are made to the StatusBlock by
;                  the USB User Module.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:      A contains the Completion Status Code
;
;  RETURNS:        None
;
;  SIDE EFFECTS: REGISTERS ARE VOLATILE: THE A AND X REGISTERS MAY BE MODIFIED!
;
;  THEORY of OPERATION or PROCEDURE:
;
;-----------------------------------------------------------------------------
USBFS_1_UpdateStatusBlock:
;Determine if we have a null pointer and if so don't update
    push A
	mov  A, [USBFS_1_StatusBlockPtr + 1]
	cmp  A, 0
    jnz  .NotNull
    mov  A, [USBFS_1_StatusBlockPtr]
	cmp  A, 0
	jnz  .NotNull
	pop  A
	jmp  .done

.NotNull:
    mov  A, [USBFS_1_StatusBlockPtr]
	RAM_SETPAGE_MVW A
	mov  A, [USBFS_1_StatusBlockPtr + 1]
    mov  [USBFS_1_t0], A
    
	pop  A
    mvi  [USBFS_1_t0], A               ; Update the completion Code 
    mov  A, [USBFS_1_TransferByteCount]; Actual Byte Count MSB
    mvi  [USBFS_1_t0], A
    mov  A, [USBFS_1_TransferByteCount + 1] ; Actual Byte Count LSB
    mvi  [USBFS_1_t0], A
    mov  [USBFS_1_StatusBlockPtr + 1], 0 ; Clear the Block Pointer    
.done:
    ret                                ; All done
;-----------------------------------------------------------------------------
;  FUNCTION NAME: USBFS_1_InitializeStatusBlock
;
;  DESCRIPTION:    Initialize the Completion Status Block for a Request.
;                  The completion code is set to USB_XFER_IDLE.
;                  
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:      None
;
;  RETURNS:        None
;
;  SIDE EFFECTS: REGISTERS ARE VOLATILE: THE A AND X REGISTERS MAY BE MODIFIED!
;
;  THEORY of OPERATION or PROCEDURE:
;
;-----------------------------------------------------------------------------
USBFS_1_InitializeStatusBlock:
;Determine if we have a null pointer and if so don't update
	mov  A, [USBFS_1_StatusBlockPtr + 1]
	cmp  A, 0
    jnz  .NotNull
    mov  A, [USBFS_1_StatusBlockPtr]
	cmp  A, 0
	jz   .done

.NotNull:
; Flow here to initialize the Completion Status Block
    mov  A, [USBFS_1_StatusBlockPtr]
	RAM_SETPAGE_MVW A
	mov  A, [USBFS_1_StatusBlockPtr + 1]
    mov  [USBFS_1_t0], A
	mov  A, USB_XFER_IDLE
    mvi  [USBFS_1_t0], A               ; Initialize the completion code (0) 
    mov  [USBFS_1_TransferByteCount], 0; Clear the byte count 
    mov  [USBFS_1_TransferByteCount + 1], 0 ; 
.done:
    ret                                ; All done



;-----------------------------------------------------------------------------
;  FUNCTION NAME: ;  USB 1st Tier Dispactch Jump Table (based on bmRequestType)
;
;  DESCRIPTION:
;
MACRO BMREQUEST_DISPATCH
IF (USB_CB_@0_@1_@2 & 1)
    jmp     USBFS_1_DT_@0_@1_@2_Dispatch
ELSE
    jmp     USBFS_1_Not_Supported_Local2
ENDIF
ENDM

USBFS_1_DT_bmRequestType::
    BMREQUEST_DISPATCH    h2d,std,dev
    BMREQUEST_DISPATCH    h2d,std,ifc
    BMREQUEST_DISPATCH    h2d,std,ep
    BMREQUEST_DISPATCH    h2d,std,oth
    BMREQUEST_DISPATCH    h2d,cls,dev
    BMREQUEST_DISPATCH    h2d,cls,ifc
    BMREQUEST_DISPATCH    h2d,cls,ep
    BMREQUEST_DISPATCH    h2d,cls,oth
    BMREQUEST_DISPATCH    h2d,vnd,dev
    BMREQUEST_DISPATCH    h2d,vnd,ifc
    BMREQUEST_DISPATCH    h2d,vnd,ep
    BMREQUEST_DISPATCH    h2d,vnd,oth
    BMREQUEST_DISPATCH    h2d,rsv,dev
    BMREQUEST_DISPATCH    h2d,rsv,ifc
    BMREQUEST_DISPATCH    h2d,rsv,ep
    BMREQUEST_DISPATCH    h2d,rsv,oth
    BMREQUEST_DISPATCH    d2h,std,dev
    BMREQUEST_DISPATCH    d2h,std,ifc
    BMREQUEST_DISPATCH    d2h,std,ep
    BMREQUEST_DISPATCH    d2h,std,oth
    BMREQUEST_DISPATCH    d2h,cls,dev
    BMREQUEST_DISPATCH    d2h,cls,ifc
    BMREQUEST_DISPATCH    d2h,cls,ep
    BMREQUEST_DISPATCH    d2h,cls,oth
    BMREQUEST_DISPATCH    d2h,vnd,dev
    BMREQUEST_DISPATCH    d2h,vnd,ifc
    BMREQUEST_DISPATCH    d2h,vnd,ep
    BMREQUEST_DISPATCH    d2h,vnd,oth
    BMREQUEST_DISPATCH    d2h,rsv,dev
    BMREQUEST_DISPATCH    d2h,rsv,ifc
    BMREQUEST_DISPATCH    d2h,rsv,ep
    BMREQUEST_DISPATCH    d2h,rsv,oth
USBFS_1_DT_End:
USBFS_1_DT_Size: equ (USBFS_1_DT_End-USBFS_1_DT_bmRequestType) / 2
USBFS_1_bmRequestType_Dispatch::

    DISPATCHER USBFS_1_DT_bmRequestType, USBFS_1_DT_Size, USBFS_1_Not_Supported_Local2 

USBFS_1_Not_Supported_Local2:
   nop
   ljmp USBFS_1_Not_Supported
; End of File USBFS_1_drv.asm
